?-
  Level=3, % from 1 to 11 
    % start_random_from(0),
  G_N=0,
  G_Selected=1,
  G_Solution=0,
  font(25,30, _ ),
  array(board,81,0),
  array(solution,81,0),
  array(fixed,81,0),
  add_to(30),
  write("You have to wait a little bit until the task is generated."), nl,
  write("If the task is too difficult then you can change the Level. "), nl,
  write("Use the right mouse button to mark positions which are not sure."), nl,
  write("The task is generated randomly. That is why the time for generation every time is different."), nl,
  write("First the program is looking for a task with a decision and after that it is looking for a task with only decision."), nl,
  write("You can play Level 11 which is the supper level. If you chose this level then you will have only decision with minimal number of fixed positions."), nl, nl,
  write("For the moment "+G_N+" positions are fixed."), nl,
    chronometer(),
    chronometer_steps(),
  make_task,
  (Level=11->
    nl, write("Creating the supper level..."), nl,
    make_supper_level
  ),
  G_K:=1,
  find(),
  fix(30- 3*Level),
    Time:=chronometer(),
    Steps:=chronometer_steps(),
    beep,
    nl, write("Ready for "+Time+" seconds ("+Steps+" steps)"),nl,
  window( title("Sudoku"), size(700,620)).

make_task:-
  G_K:=0,
  (find()-> % many solutions
    G_Solution:=1,
    clean_solution,
    nl, write("+1 "),
    G_N2 := G_N+1,
    add_to(G_N2),
    make_task
  else (G_K=0-> % no solution
    (G_Solution=0->
      nl, write("-3"),
      G_N:=G_N - 3,
      delete(), delete(), delete()
    else
      write("+0"),
      board(G_A+9*G_B):=0,
      solution(G_A+9*G_B):=0,
      fixed(G_A+9*G_B):=0,
      G_N := G_N - 1,
      add_to(G_N2)
    ),
    make_task
   )).

clean_solution:-
  for(I,0,8), 
    for(J,0,8),
      (fixed(I+9*J) =\= 1 ->
        solution(I+9*J):=0
      ), 
      fail.    
clean_solution.

make_supper_level:-
  for(J,0,8),
    for(I,0,8), 
      (fixed(I+9*J) =:= 1 ->
        X is solution(I+9*J),
        board(I+9*J):=0,
        solution(I+9*J):=0,
        fixed(I+9*J):=0,
        G_K:=0,
        (not(find())-> % one solution
          nl, write("-1 ")
        else % many solutions
          write("-0"),
          board(I+9*J):=X,
          solution(I+9*J):=X,
          fixed(I+9*J):=1
        )
      ), 
      fail.    
make_supper_level.

win_func(paint):- 
  pen(3,rgb(0,0,0)),
  line(50,50,50,500,500,500,500,50,50,50),
  line(550,50,600,50,600,550,550,550,550,50),
  draw_matrix(50,50,150),
  pen(1,rgb(0,0,0)),
  make_line,
  for(I,0,2),
    for(J,0,2),
      draw_matrix(150*I+50,150*J+50,50), 
  fail. 
        
win_func(paint):-
  for(I,0,8), 
    for(J,0,8),
      (fixed(I+9*J) =:= 1 -> 
        color_text(_,rgb(255,0,0)),
        text_out( print( solution(I+9*J) ), pos(50*I+58,50*J+58) )
      else (board(I+9*J) > 0 ->
        X is board(I+9*J),
        board(I+9*J) := 0,
        (not( in_row(board, X,J) ),
         not( in_column(board, X,I) ),
         not( in_sqrt(board, X,I,J) )->
          (fixed(I+9*J) =\= 2->
            color_text(_,rgb(0,0,0))
          else
            color_text(_,rgb(0,0,255))
          )
        else
          color_text(_,rgb(0,220,0))
        ), 
        board(I+9*J) := X,
        text_out( print( board(I+9*J) ), pos(50*I+58,50*J+58) )
      )),
      fail.    
 
win_func(mouse_click(X,Y)):- 
  mouse_click(X,Y,left).

win_func(r_mouse_click(X,Y)):-
  mouse_click(X,Y,right).

mouse_click(X,Y,LR):- 
  A is (X // 50) - 1,
  B is (Y // 50)- 1,
  (A >=0, A<9, B >=0, B<9->
    (fixed(A+ 9*B) =\= 1 ->
      board(A+9*B) := 0,
      (G_Selected>0->
        (not( in_row(board, G_Selected,B) ),
         not( in_column(board, G_Selected,A) ),
         not( in_sqrt(board, G_Selected,A,B) )->
          (LR=left->
            fixed(A+9*B) := 0,
            color_text(_,rgb(0,0,0))
          else
            fixed(A+9*B) := 2,
            color_text(_,rgb(0,0,255))
          )
        else
          color_text(_,rgb(0,220,0))
        ), 
        text_out(print(G_Selected), pos(58+50*A,58+50*B))
      else
        text_out("  ", pos(58+50*A,58+50*B))
      ),
      board(A+9*B) := G_Selected
    ),
    (not(bad)->
      message("","OK",!)
    )
  else (A=10, B >=0, B<10->
    (G_Selected>0->
      color_text(_,rgb(0,0,0)),
      text_out(print(G_Selected), pos(560,15+50*G_Selected) )
    ),
    G_Selected:=B+1,
    (G_Selected<10->
      color_text(_,rgb(255,0,0)) ,
      text_out(print(G_Selected), pos(560,15+50*G_Selected) )
    else
      G_Selected:=0
    )
  )).


draw_matrix(X,Y,S):- 
  line(X+S,Y,X+S,Y+3*S),
  line(X+2*S, Y,X+2*S,Y+3*S),
  line(X,Y+S,X+3*S,Y+S),
  line(X,Y+2*S,X+3*S,Y+2*S).

make_line:-
  for(I,1,9),
    line(550,50+50*I,600,50+50*I),
    (I=G_Selected->
      color_text(_,rgb(255,0,0))
    else 
      color_text(_,rgb(0,0,0)) 
    ),
    text_out(print(I), pos(560,15+50*I) ),
    fail.
make_line.

in_row(S,I,B):-
  for(J,0,8),
    S(J+ 9*B) =:= I.

in_column(S,I,A):-
  for(J,0,8),
    S(A + 9*J)=:=I.
 
in_sqrt(S,E,A,B):-
  A1 is 3* (A // 3),
  B1 is 3* (B // 3), 
  for(I,0,2),
    for(J,0,2),
      S(A1+I+ 9*B1 + 9*J)=:=E.
    
fill_pos(N):- 
  for(K,1,N),
    G_A := random(9),
    G_B := random(9),
    fixed(G_A+9*G_B)=\=1,
    X is 1+random(9),
    not( in_row(solution, X,G_B) ),
    not( in_column(solution, X,G_A) ),
    not( in_sqrt(solution, X,G_A,G_B) ),
    G_N:=G_N+1,
    board(G_A+9*G_B):=X,
    solution(G_A+9*G_B):=X,
    fixed(G_A+9*G_B):=1,
    fail.
fill_pos(_).

fix(N):- 
  for(K,1,N),
    A is random(9),
    B is random(9),
    board(A+9*B) := solution(A+9*B),
    fixed(A+9*B):=1,
    fail.
fix(_).

delete():-
  repeat,
  A is random(9),
  B is random(9),
  fixed(A+9*B)=:=1, !,
  board(A+9*B):=0,
  solution(A+9*B):=0,
  fixed(A+9*B):=0.

add_to(N):-
  repeat,
  fill_pos(1),
  G_N=:=N, !.

bad:-
  for(I,0,8), 
    for(J,0,8),
      fixed(I+9*J) =\= 1,
      solution(I+9*J) =\= board(I+9*J).

can_we_put(Place, Num, Successes, Min):-
  A is Place mod 9, 
  B is Place // 9,
  Successes:=0, 
  for(I,1,9),
    not( in_row(solution, I,B) ),
    not( in_column(solution, I,A) ),
    not( in_sqrt(solution, I,A,B) ),
    Successes:=Successes+1,
    Num:=I,
  Successes >= Min.

check_if_possible(81, _, _):- !.
check_if_possible(Start, Next, Min):-
  (solution(Start)=:=0->
    (can_we_put(Start, Num, Successes, Min)->
      true
    else (Successes =:= 1 ->
      solution(Start) has_to Num
    else (Successes > 1 ->
      Next:=Start,
      Min:=Successes
    else % if 0 then not possible
      fail
    )))
  ),
  Start2 is Start+1, 
  check_if_possible(Start2, Next, Min).

find():-
  check_if_possible(0, Next, 10),
  (var(Next)->
    G_K:=G_K+1, G_K>1
  else 
    A is Next mod 9, 
    B is Next // 9, 
    for(I,1,9),
      not( in_row(solution, I,B) ),
      not( in_column(solution, I,A) ),
      not( in_sqrt(solution, I,A,B) ),
      solution(Next) has_to I,
      find() 
  ).
 