% Metro.pro, version 3.2
% January 19, 2020

include("metro_map.h"). % try 1, 2, 3, 4
include("metro_data.h").
include("metro_window.h").
include("metro_tools.h").

?-
  init_map,
  initialisation,
  % H is open("test.metro", "rb"),  read_metro(H),  close(H),
  (G_BigSize=:=1 -> P:= 100, X := 1900, Y := 740 else P:= 10, X := 1350, Y := 700),
  window(title("Metro"), pos(0, P), size(X, Y), backgr(rgb(0, 200, 200)), paint_indirectly, h_scroll,v_scroll).
  % change_speed.

time_func(end):-
  G_Pause =:= 0,
  start_random_from(G_Time), % make the random deterministic
  (G_Time mod G_time_period =:= 0, G_WagonNum<G_Wagons_in_use ->
    G_Number := (G_Number+1) mod 10,
    (G_Number =:= 0 -> G_NextColor := (G_NextColor+1) mod 8),
    semaphore(8+4):=1,
    wagon_color(G_NextColor, Color),
    wColor(G_WagonNum) := Color,
    wPosoka(G_WagonNum) := 1,
    wagonY(G_WagonNum) := 1000, % +500
    G_First := G_WagonNum,
    (G_WagonNum=:=0 ->
      wPrevious(G_WagonNum) := -1
    else
      wNext(G_WagonNum-1) := G_WagonNum,
      wPrevious(G_WagonNum) := G_WagonNum-1
    ),
    wNext(G_WagonNum) := -1,
    wagonX(G_WagonNum) := -24000,
    %wagonX(G_WagonNum) := 0-20*Number*(5-Speed),
    wNumber(G_WagonNum) := G_Number,
    Speed := main_speed,
    (G_Traffic =:= 3 ->
      next_stop(G_Number, Jump, Stop),
      wJump(G_WagonNum) := Jump,
      wStop(G_WagonNum) := Stop,
      stop_at_pos(G_WagonNum, Stop, 0),
      (G_Different_Speeds =:= 1 ->
        different_speeds( Jump, Add),
        Speed := main_speed+Add
      )
    else
      wJump(G_WagonNum) := -1*G_Traffic,
      wStop(G_WagonNum) := 1,
      G_Traffic := G_Number mod 2,
      stop_at_pos(G_WagonNum, 1, 0)
    ),
    wSpeed(G_WagonNum) := Speed,
    wTargetSpeed2(G_WagonNum) := Speed,
    wFlags(G_WagonNum) := 0,
    (G_WagonNum>0->
      Distance := wagonX(G_WagonNum-1)-2000,
      Distance := Distance-(wSpeed(G_WagonNum)**2)/G_Crazy_Speed+(wSpeed(G_WagonNum-1)**2)/2,
      wagonX(G_WagonNum):= min(wagonX(G_WagonNum), Distance)
    ),
    Distance := wStopAt(G_WagonNum)-wagonX(G_WagonNum) - 0.5*wSpeed(G_WagonNum)**2,
    (Distance < 0 ->
      wagonX(G_WagonNum) := wagonX(G_WagonNum) + Distance
    ), 
    G_WagonNum := G_WagonNum + 1
  ),
  G_Time := G_Time + 1,
  (G_Time mod 600=:=0 -> write("One minute for "+chronometer()/60), nl),
  move_wagons,
  (G_Time mod 10=:=0; G_FastSpeed=:= -1 ->
    set_main_window_text
  ),
  G_Run_Invisible =:= 0,
  (G_Time mod 2=:=0; G_FastSpeed=\= 1 ->
    update_window(_)
  ).

next_stop(0, 1, 1).
next_stop(1, 2, 2).
next_stop(2, 2, 1).
next_stop(3, 3, 3).
next_stop(4, 3, 2).
next_stop(5, 3, 1).
next_stop(6, 4, 4).
next_stop(7, 4, 3).
next_stop(8, 4, 2).
next_stop(9, 4, 1).

move_wagons:-
  for(I, 0, G_WagonNum-1),
  wOldX(I) := wagonX(I),
  (wCount(I)>0->
    (wAcceleration(I) =:=0, G_Unexpected_Delay=:=1->
      Delay := random(frequency_fild),
      (Delay =< 2*unexpected_delay->
        (Delay=:=unexpected_delay->
          % write("Big problem i="+I), nl,
          wCount(I) := wCount(I) + random(1+big_problem)
        else
          wCount(I) := wCount(I) + Delay - unexpected_delay,
          (wCount(I)<1 -> wCount(I):=1)
        )
      )
    ),
    wCount(I) := wCount(I)-1
  else (wAcceleration(I)>0->
    change_speed(I, 1)
  else (wAcceleration(I)<0->
    change_speed(I, -1)
  ))),
  (in_curve(I, X, Y, Sign, R)->
    Alfa := arccos((wagonX(I)-X)/R),
    %write(wagonX(I)+"="+Alfa+"="+cos(Alfa - wSpeed(I)/4625)*4625), nl,
    wagonX(I) := X+cos(Alfa - wSpeed(I)/R)*R,
    wagonY(I) := Y+wPosoka(I)*Sign*(R-sin(Alfa - wSpeed(I)/R)*R)
  else
    wagonX(I) := wagonX(I) + wSpeed(I)
  ),
  % (I=9, wSpeed(I)<200-> write("speed="+wSpeed(I)+" "+G_Time), nl),
  fail.
move_wagons:-
  for(I, 0, G_WagonNum-1),
  NextSpeed := wSpeed(I) + (wPosoka(I)*wAcceleration(I)>0 -> wAcceleration(I) else 0),
  (2*wPosoka(I)*(wStopAt(I)-wagonX(I)-wSpeed(I)-wAcceleration(I))<NextSpeed**2->
    wFlags(I):=(wFlags(I)\/64)/\0xffce,
    (wPosoka(I)*wSpeed(I)>0->
      Acceleration := -1*wPosoka(I), % 0.5*wSpeed(I)**2/(wagonX(I)-wStopAt(I)),
      wTargetSpeed2(I) := 0,
      move_train(I, Acceleration, 0)
    )
  else (wFlags(I)/\32=\=0->
    (wPrevious(I)=\= -1->
      calc_Distanse(Distanse, Limit, I),
      (2*Distanse<Limit->
        move_train(I, -1*wPosoka(I), 0)
      else (Distanse<Limit->
        move_train(I, -0.5*G_Crazy_Speed*wPosoka(I), 0)
      else (0.8*Distanse-100>Limit-> % 0.8 coef. and 100 coef.
        end_of_slowdown(I)
      else
        move_train(I, 0, 0)
      )))
    else
      end_of_slowdown(I)
    )
  else (wFlags(I)/\5=:=0, wPrevious(I)=\= -1->
    calc_Distanse(Distanse, Limit, I),
    (Distanse<Limit->
      wFlags(I):=wFlags(I)\/32,
      move_train(I, -0.5*G_Crazy_Speed*wPosoka(I), 0)
    else (wFlags(I)/\64=\=0->
      wFlags(I):=wFlags(I)/\0xffbf,
      move_train(I, -0.5*wPosoka(I), 0)
    )),
    (wFlags(I)/\16=\=0, 0.97*Distanse<Limit -> % 0.97 coef.
      wFlags(I):=wFlags(I)/\0xffef,
      speedup_all(wPrevious(I))
    )
  else (wFlags(I)/\64=\=0->
    wFlags(I):=wFlags(I)/\0xffbf,
    move_train(I, -0.5*wPosoka(I), 0)
  )))),
  fail.
move_wagons:-
  for(I, 0, G_WagonNum-1),
  (wFlags(I)/\2=\=0, semaphore(8-4*wPosoka(I))=:=0,
          wPrevious(I) =:= -1,
          not(wPosoka(I)=:= -1, G_WagonNum<G_Wagons_in_use)->
      start_wagon(I)
  else (wSpeed(I)=:=0, wCount(I)=:=0, wAcceleration(I)=:=0 ->
    %write("i="+I+", "+G_Time+"="+wFlags(I)+"="+wAcceleration(I)), nl,
    (wFlags(I)/\8=\=0->
      return_wagon(I)
    else (wFlags(I)/\4=\=0->
      init_wagon(I)
    ))
  )),
  fail.
move_wagons:-
  for(I, 0, G_WagonNum-1),
  where_to_stop(Type, I, N, StationX, Semaphore),
  cross_point(Type, I, N, StationX, Semaphore),
  fail.
move_wagons.

change_speed(I, Sing):-
  (Sing*wTargetSpeed(I)-1>Sing*(wSpeed(I)+wAcceleration(I))->
    wSpeed(I) := wSpeed(I)+wAcceleration(I)
  else
    % write("i="+I+", "+G_Time+"=="+wFlags(I)+"="+wAcceleration(I)), nl,
    (abs(wTargetSpeed(I)-wSpeed(I))-1>abs(wAcceleration(I))-> write("Opposite acceleration! i="+I+" speed=("+wSpeed(I)+","+wTargetSpeed(I)+") Acceleration="+wAcceleration(I)+" now="+G_Time), nl),
    wSpeed(I) := wTargetSpeed(I),
    wAcceleration(I) :=0,
    (wTargetSpeed(I)=:=0 ->
      (wFlags(I)/\8=:=0, abs(wStopAt(I)-wagonX(I))<500 -> % 500 coef.
        (wStop(I)=:=0, wFlags(I)/\2=:=0->
          wFlags(I):=4,
          % wCount(I):= 100
          wCount(I):=wait_time+random(1+2*plus_minus)-plus_minus
        )
      )      
    )
  ).

where_to_stop(Type, I, N, StationX, Semaphore):-
  station(yes, N, StationX, Semaphore, _, _),
  abs(StationX-wagonX(I))<43000,
  stop_point(Type, Point),
  (wPosoka(I)=:=1->
    wOldX(I) =< Point+StationX, Point+StationX< wagonX(I)
  else
    wOldX(I) >= -1*Point+StationX, -1*Point+StationX> wagonX(I)
  ).

stop_point(enter_switch, -5000).

cross_point(enter_switch, I, N, StationX, _):-
  wStop(I) := wStop(I)-1,
  (wNext(I)=:= -1-> % switch
    N =:= finish_station(-1*wPosoka(I)),
    semaphore(8+4*wPosoka(I)) := 0
  ).

