R is main_speed :- R:=200.0.  % 200 cm/ds = 20 m/s = 72 km/h
R is max_speed :- R:=240.0.   %             24 m/s = 86 km/h
R is wait_time :- R:=100. % 10 seconds = 100 deciseconds (ds)
R is plus_minus :- R:=50. % 5 seconds
R is big_problem :- R:=1000. % big_problem < 2*frequency_fild
R is unexpected_delay :- R:=20.
R is frequency_fild :- R:=2000.
 % big problem frequency = 1/frequency_fild 
 % unexpected delay frequency = (2*unexpected_delay)/frequency_fild 
R is max_wagons :- R:=400.
R is add :- R:= 2*(arcsin(1500/4625)*4625-1500).

initialisation:-
  G_ExtraDistance := 200,
  G_Dont_Wait_Dis := 10000,
  G_Traffic := 3, % 0 - second low, 1 - first low, 2 - start low, 3 - heavy
  G_Traffic2 := 3,
  G_time_period := (G_Traffic =:= 3 -> G_time_period_fast else integer(1.5*G_time_period_fast)),
  G_Wagons_in_use := 10*(G_Wagons_in_use//10)+(2*count_successes(station(yes, _, _, _, _, _))) mod 10,
  max_wagons>=G_Wagons_in_use,
  G_Number := 9,
  G_Number2 := (G_Number+count_successes(station(yes, _, _, _, _, _))) mod 10,
  G_Odd_Stations := (count_successes(station(yes, _, _, _, _, _))) mod 2,
  G_First := -1,
  G_First2 := -1,
  size(screen, _, H),
  G_BigSize := true_value(H>=1080),
  (G_BigSize=:=1 ->
    G_PosX := -13000.0,
    G_Zoom := 0.1
  else
    G_PosX := -10000.0,
    G_Zoom := 0.09
  ),
  G_PosY := -2000.0,
  G_PosSmall := 0,
  G_ScrollRange := 1000,
  G_Time := 0,
  G_WagonNum := 0,
  G_NextColor := 0,
  G_Unexpected_Delay := 0,
  G_Crazy_Speed := 1, % 2 for crazy speed, 1 for careful stop
  G_Different_Speeds := 1, % the same average speed, even less, but with variations from -2 to +4
  G_Pause := 0,
  G_Run_Invisible := 0,
  G_FastSpeed := 0,
  G_Last_Speed := 0,
  G_map_list := 0,
  G_MenuNumber := 0,
  G_Statistic_Course:=0,
  G_Statistic_Last:=0,
  G_Statistic_Time:=0,
  G_moveX:=no,

  array(wagonX, max_wagons, -33000),
  array(wagonY, max_wagons, 1000),
  array(wPosoka, max_wagons, 1),
  array(wOldX, max_wagons, 0),
  array(wJump, max_wagons, 0),
  array(wStop, max_wagons, 0),
  array(wNumber, max_wagons, 0),
  array(wSpeed, max_wagons, main_speed),
  array(wTargetSpeed, max_wagons, 0.0),
  array(wTargetSpeed2, max_wagons, 0.0),
  array(wStopAt, max_wagons, 0),
  array(wAcceleration, max_wagons, 0.0), % 1 = 1 m/s2
  array(wCount, max_wagons, 0),
  array(wColor, max_wagons, rgb(0, 255, 0)),
  array(wNext, max_wagons, -1),
  array(wPrevious, max_wagons, -1),
  array(wFlags, max_wagons, 0),
  %  1 - the next in the train (this wagon will stop together with the previous one)
  %  2 - wait the semaphore to switch
  %  4 - the door is open
  %  8 - return this wagon
  % 16 - run with max speed
  % 32 - stopping to prevent crash
  % 64 - stopping to stop

  array(semaphore, 400, 0),
  array(arrive_line, 4, 0),
  array(wagon_arrive, 13, 0),
  array(wagon_time, 13, 0),
  _ is chronometer().

convert_brush(6, 1).
convert_brush(8, 3).
convert_brush(9, 2).

make_brush(-1):- brush(rgb(200, 200, 255)).
make_brush(0):- brush(rgb(255, 255, 255)).
make_brush(1):- brush(rgb(0, 127, 0)).
make_brush(2):- brush(rgb(0, 0, 255)).
make_brush(3):- brush(rgb(255, 255, 0)).
make_brush(4):- brush(rgb(255, 0, 0)).
make_brush(12):- brush(rgb(255, 200, 200)).
  
wagon_color(1, rgb(255, 255, 0)).
wagon_color(2, rgb(255, 0, 0)).
wagon_color(3, rgb(0, 255, 255)).
wagon_color(4, rgb(0, 0, 255)).
wagon_color(5, rgb(255, 255, 255)).
wagon_color(6, rgb(128, 0, 128)).
wagon_color(7, rgb(0, 255, 0)).
wagon_color(0, rgb(255, 0, 255)).

