statistic(I):-
  (I=:=0->
    G_Statistic_Course:=G_Statistic_Course+1,
    G_Statistic_Last:=G_Time-G_Statistic_Time,
    G_Statistic_Time:=G_Time,
    G_Statistic_averSpeed:=(end_map+500000)/G_Statistic_Last, nl,
    Wagons_will_stop:= (wJump(0)>0 -> 16/100 else 10/10),
    Aver := G_Time/G_Statistic_Course,
    write("     Course "+G_Statistic_Course),
    write(". (Length "+(end_map+500000)/100000+" km, "+G_Wagons_in_use+" wagons in use)"), nl, nl,
    write("This Course:"), nl,
    write("      Duration = "+G_Statistic_Last//10+" s ("+G_Statistic_Last/36000+" h)"),
    write("  aver. "+Aver//10+" s"), nl,
    write("         Speed = "+(0.36*G_Statistic_averSpeed)+" km/h"),
    write("       aver. "+(G_Statistic_Course*0.36*(end_map+500000)/G_Time)+" km/h"), nl,
    write("       Dencity = "+(600*0.5*G_Wagons_in_use/G_Statistic_Last)+" wagons/min"),
    write(" aver. "+(600*0.5*G_Wagons_in_use/Aver)+" wagons/min"), nl,
    write("Wait on station = "+(G_Statistic_Last/(G_Wagons_in_use*Wagons_will_stop))//10+" s"), % divide on 2 because we wait 
    write("              aver. "+(Aver/(G_Wagons_in_use*Wagons_will_stop))//10+" s"), nl, nl    % aver. half of the time (2/0.5=1)
  ).

move_train(I, A, S):-
  wAcceleration(I) := A,
  wTargetSpeed(I) := S,
  (wNext(I)=\= -1, wFlags(wNext(I))/\1=\=0->
    move_train(wNext(I), A, S)
  ).

calc_Distanse(Distanse, Limit, I):-
  Distanse := 0.8*(abs(wagonX(wPrevious(I))-wagonX(I))-2000-G_ExtraDistance), % 0.8 coef.
   % -(abs(wSpeed(I)-wSpeed(wPrevious(I)))>40; wAcceleration(wPrevious(I)) =:= -1*wPosoka(I)-> 800 else 0),  % 40, 800 coef.
  Limit := max(0, (wSpeed(I)**2)/G_Crazy_Speed-(wSpeed(wPrevious(I))**2)/2).

end_of_slowdown(I):-
  wFlags(I):=wFlags(I)/\0xffdf,
  (abs(wSpeed(I))<abs(wTargetSpeed2(I))-> 
    move_train(I, wPosoka(I), wTargetSpeed2(I))
  else
    move_train(I, 0, 0)
  ).

in_curve(I, X, Y, Sign, R):-
  get_local_arc(wagonX(I), X, Y, Sign, Q1, Q2, R, Semaphore),
  (wPosoka(I)*X<wPosoka(I)*Q1->
    (abs(X-wagonX(I))<600, abs(Y-wagonY(I))<200, Semaphore\=no->
      (semaphore(Semaphore)=:=0 -> fail)
    else
      wagonY(I)>1010, wagonY(I)<1490
    ),
    wPosoka(I)*wagonX(I)>=wPosoka(I)*X,
    wPosoka(I)*wagonX(I)<wPosoka(I)*Q1
  else
    wagonY(I)>1010, wagonY(I)<1490,
    wPosoka(I)*wagonX(I)>=wPosoka(I)*Q1,
    wPosoka(I)*wagonX(I)<wPosoka(I)*X,
    Sign := -1*Sign
  ).

start_wagon(I):-
  stop_at_pos(I, wStop(I), 1),
  (abs(wSpeed(I)) < main_speed ->
    move_train(I, wPosoka(I), wPosoka(I)*main_speed)
  else
    move_train(I, 0, 0)
  ).

different_speeds( 1, 40).
different_speeds( 2, 20).
different_speeds( 3, 0).
different_speeds( 4, -20).

init_wagon(I):-
  wJump(I) > 0,
  wJump(I) := 1 + wJump(I) mod 4,
  wStop(I) := wJump(I),
  wFlags(I):= 0,
  stop_at_pos(I, wStop(I), 0),
  (G_Different_Speeds =:= 0 ->
    Speed := main_speed
  else
    Jump := wJump(I),
    Previous := wPrevious(I),
    (Previous =\= -1, Jump =:= wJump(Previous) ->
% write(I+" *"), nl,
      Speed := max_speed
    else
      different_speeds(Jump, Add),
      Speed := main_speed+Add
    ),
    (Jump > 1, last_in_group(Last, I, Jump), abs(wagonX(I)-wagonX(Last)) > 30000*(Jump+2) ->
% write(I+" "+Last+" "+Jump), nl,
      speedup_all(Last)
    )
  ),
  move_train(I, wPosoka(I), wPosoka(I)*Speed),
  wTargetSpeed2(I) := wPosoka(I)*Speed.

init_wagon(I):-
  wJump(I) =< 0,
  wStop(I) := 1,
  wFlags(I):= 0,
  stop_at_pos(I, 1, 0),
  move_train(I, wPosoka(I), wPosoka(I)*main_speed),
  wTargetSpeed2(I) := wPosoka(I)*main_speed.

speedup_all(I):-
  Previous := wPrevious(I),
  (Previous =\= -1, wJump(I) =:= wJump(Previous) ->
    move_train(I, wPosoka(I), wPosoka(I)*max_speed),
    wTargetSpeed2(I) := wPosoka(I)*max_speed,
    (wFlags(I)/\32=\=0 ->
      speedup_all(Previous)
    else
      wFlags(I):= wFlags(I)\/16
    )
  ).

last_in_group(Last, I, Jump):-
  Last1 := wNext(I),
  Last1 =\= -1,
  wJump(Last1) =:= wJump(I), % probelm if it is more than 10 stops away
  (Jump > 1 ->
    last_in_group(Last, Last1, Jump-1)
  else
    Last := Last1
  ).

return_wagon(I):-
  All := (wStop(I)=:=wJump(I) -> (wJump(I)=:=1 -> 3 else wJump(I)) else (wJump(I)=:= -1 -> 2 else wStop(I))),
  all_are_stopped(I, All),
  semaphore(8-4*wPosoka(I)):=1,
  return_all(I, All, I),
  update(I).

all_are_stopped(_, All):- All < 2, !.
all_are_stopped(Previous, All):-
  I := wNext(Previous),
  % write(wNumber(I)+" "+wNumber(Previous)+" "+All), nl,
  (I =\= -1, true_value(wJump(I)>0)=:=true_value(wJump(Previous)>0) ->
    Where := finish_station(wPosoka(I)),
    station(yes, Where, StationX, _, _, _),
    (wPosoka(I)*(wagonX(Previous)-wagonX(I)) > G_Dont_Wait_Dis,
     wPosoka(I)*(StationX-wagonX(I)) > (wSpeed(I)**2)/2 - 4000 -> % prevent crash
      (wPosoka(I)*(wStopAt(I)-StationX) > 4000 ->
        wStopAt(I):= 4000*wPosoka(I)+StationX,
        wFlags(I):= wFlags(I)\/2
      )
    else ((wNumber(I)-wNumber(Previous)) mod 10 < All -> % don't wait if mixed
      wSpeed(I)=:=0,
      wPosoka(I)*(wagonX(I)-StationX)>9000-150, % 150 coef.
      All2:= All-(wNumber(I)-wNumber(Previous)) mod 10,
      all_are_stopped(I, All2)
    ))
  ).

return_all(Last, All, First):-
  statistic(Last),
  I := wNext(Last),
  Where := finish_station(wPosoka(I)),
  station(yes, Where, StationX, _, _, _),
  (All>1, I =\= -1, true_value(wJump(I)>0)=:=true_value(wJump(Last)>0), wPosoka(I)*(wagonX(I)-StationX)>9000-150 -> % 150 coef.
    All2:= All-(wNumber(I)-wNumber(Last)) mod 10,
    return_all(I, All2, First),
    update(I),
    wPrevious(Last):=I,
    wNext(I):=Last
  else
    % write("Last="+Last+" First="+First+" Second="+Second),nl,
    (wPosoka(I)=:= 1->
      (G_First2 =\= -1 -> wNext(G_First2):=Last),
      wPrevious(Last):=G_First2,
      G_First2 := First
    else
      (G_First =\= -1 -> wNext(G_First):=Last),
      wPrevious(Last):=G_First,
      G_First := First
    ),
    wNext(First):= -1,
    wPrevious(I):= -1
  ).

update(I):-
  (wPosoka(I)=:= 1 ->
    G_Number2 := (G_Number2+1) mod 10,
    Number :=G_Number2,
    Traffic = G_Traffic2
  else
    G_Number := (G_Number+1) mod 10,
    Number :=G_Number,
    Traffic = G_Traffic
  ),
  wNumber(I) := Number,
  Speed := main_speed,
  (Traffic =:= 3 ->
    next_stop(Number, Jump, Stop),
    wJump(I) := Jump,
    wStop(I) := Stop,
    (G_Different_Speeds =:= 1 ->
      different_speeds( Jump, Add),
      Speed := main_speed+Add
    )
  else
    wJump(I) := -1*Traffic,
    wStop(I) := 1,
    Traffic := (wPosoka(I)=:= 1 -> Number + G_Odd_Stations else Number) mod 2
  ),
  wPosoka(I):= -1*wPosoka(I),
  wFlags(I):= 0,
  stop_at_pos(I, wStop(I), 0),
  wAcceleration(I):= wPosoka(I),
  wTargetSpeed(I) := wPosoka(I)*Speed,
  wTargetSpeed2(I) := wPosoka(I)*Speed.

make_platform(0, 2).
make_platform(1, 0).
make_platform(2, 0).
make_platform(3, 1).
make_platform(4, 1).
make_platform(5, 1).
make_platform(6, 3).
make_platform(7, 3).
make_platform(8, 3).
make_platform(9, 3).

pos_point(-2, Platform, N, I):-
  Point := (wPosoka(I)*(N - finish_station(-1*wPosoka(I))) + wNumber(I)) mod 10,
  make_platform(Point, Platform).
pos_point(-1, 2, _, _).
pos_point( 0, 0, _, _).
pos_point( 4, 3, _, _).
pos_point( 1, 2, _, _).
pos_point( 3, 1, _, _).
pos_point( 2, 0, _, _).

stop_at_pos(Wagon, Stop, Start):-
  (between_stations(Wagon, N)->
    stop_at_pos2(Wagon, Stop-1, N, Start)
  else
    local_station(wagonX(Wagon), StationX, _),
    (wPrevious(Wagon) =\= -1, (wJump(Wagon)=:=2, wJump(wPrevious(Wagon))=:=1; wJump(Wagon)=:=0, wJump(wPrevious(Wagon))=:= -1); Start=:=1 ->
      (wJump(Wagon)=<0-> 
        wStopAt(Wagon):= ((1+true_value(wJump(Wagon)=:= -1))*(2000+G_ExtraDistance)-G_ExtraDistance+7000)*wPosoka(Wagon)+StationX
      else(wJump(Wagon)=:=1-> 
        wStopAt(Wagon):= (13000+2*G_ExtraDistance)*wPosoka(Wagon)+StationX
      else
        wStopAt(Wagon):= (Stop*(2000+G_ExtraDistance)-G_ExtraDistance+7000)*wPosoka(Wagon)+StationX
      )),
      (wJump(Wagon)=:=wStop(Wagon), (wJump(Wagon)=\=2; wPrevious(Wagon) =:= -1); wJump(Wagon)=:= -1; wJump(Wagon)=:= -2; Start=:=1 ->
        wFlags(Wagon):= 8
      )
    else 
      wStopAt(Wagon):= 4000*wPosoka(Wagon)+StationX,
      wFlags(Wagon):= 2
    )
  ).
  % write("Wagon="+Wagon+" StopAt="+wStopAt(Wagon)), nl.

stop_at_pos2(Wagon, Stop, N, Start):-
  station(yes, N, StationX, _, _, _),
  (Stop=:=0->
    Jump := wJump(Wagon),
    pos_point(Jump, Platform, N, Wagon),
    wStopAt(Wagon):= (Platform*(2000+G_ExtraDistance)-3000-1.5*G_ExtraDistance)*wPosoka(Wagon)+StationX
  else (next_station(Wagon, N, Next)->
    stop_at_pos2(Wagon, Stop-1, Next, Start)
  else
    Previous := wPrevious(Wagon),
    (Previous=\= -1, (wJump(Wagon)>0, wJump(Previous)>0, (wNumber(Wagon)-wNumber(Previous)) mod 10 =< wJump(Wagon)-Stop; wJump(Wagon)=<0, wJump(Previous)=<0); Start=:=1 -> 
      wStopAt(Wagon):= (Stop*(2000+G_ExtraDistance)-G_ExtraDistance+7000)*wPosoka(Wagon)+StationX,
      (Start=:=1 -> wFlags(Wagon):= 8)
    else
      wStopAt(Wagon):= 4000*wPosoka(Wagon)+StationX,
      wFlags(Wagon):= 2
    )
  )).

between_stations(Wagon, N):-
  station(yes, N, Station, _, _, _),
  wPosoka(Wagon)*wagonX(Wagon) =< wPosoka(Wagon)*Station-4000,
  (previus_station(Wagon, N, Previus)->
    station(yes, Previus, Station2, _, _, _),
    wPosoka(Wagon)*wagonX(Wagon) > wPosoka(Wagon)*Station2-4000
  ).

previus_station(Wagon, N, Previus):-
  N =\= finish_station(-1*wPosoka(Wagon)),
  Previus := N-wPosoka(Wagon).

next_station(Wagon, N, Next):-
  N =\= finish_station(wPosoka(Wagon)),
  Next := N+wPosoka(Wagon).
